VERSION 5.00
Object = "{48E59290-9880-11CF-9754-00AA00C00908}#1.0#0"; "MSINET.OCX"
Begin VB.Form frmAddIns 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Get Code Add-Ins"
   ClientHeight    =   4950
   ClientLeft      =   45
   ClientTop       =   585
   ClientWidth     =   5655
   Icon            =   "frmAddIns.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4950
   ScaleWidth      =   5655
   StartUpPosition =   3  'Windows Default
   Begin InetCtlsObjects.Inet Inet1 
      Left            =   2520
      Top             =   1800
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
   End
   Begin VB.Frame Frame1 
      Caption         =   "Get Code Add-Ins"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   4695
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   5415
      Begin VB.CommandButton cmdDownload 
         Caption         =   "Download"
         BeginProperty Font 
            Name            =   "Arial"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   2760
         TabIndex        =   3
         Top             =   4200
         Width           =   2535
      End
      Begin VB.CommandButton cmdGetList 
         Caption         =   "Get List"
         BeginProperty Font 
            Name            =   "Arial"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   120
         TabIndex        =   2
         Top             =   4200
         Width           =   2535
      End
      Begin VB.ListBox lstAddIns 
         BeginProperty Font 
            Name            =   "Arial"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   3900
         Left            =   120
         Style           =   1  'Checkbox
         TabIndex        =   1
         Top             =   240
         Width           =   5175
      End
   End
End
Attribute VB_Name = "frmAddIns"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
' Get Code Add-Ins
' By Patrick Gillespie (PAT or JK)
' Date: April 5, 2007
'
' Feel free to use this code in your own projects

Dim dirName As String

Private Sub cmdDownload_Click()
    On Error GoTo Err

    Dim b() As Byte
    Dim i As Integer
    Dim fNum As Long
    Dim outputLoc As String
    Dim itemSelected As Boolean
    itemSelected = False

    ' create the add-in directory if it doesn't exist
    If Dir(dirName, vbDirectory) = "" Then
        MkDir (dirName)
    End If

    ' download the selected file
    For i = 0 To lstAddIns.ListCount - 1
        If lstAddIns.Selected(i) = True Then
            b() = Inet1.OpenURL("http://www.patorjk.com/CodeAddIns/" + lstAddIns.List(i), icByteArray)

            outputLoc = dirName + "\" + lstAddIns.List(i)

            fNum = FreeFile
            Open outputLoc For Binary As #fNum
            Put #fNum, , b()
            Close #fNum

            itemSelected = True
        End If
    Next
    
    If itemSelected = True Then
        MsgBox "Finished downloading file(s). You will need to restart the API Spy in order to use them.", vbInformation, "Notice"
    Else
        MsgBox "You must select at least one file to download.", vbInformation, "Notice"
    End If

    Exit Sub
Err:
    MsgBox "An error occurred while trying to download the file(s).", vbCritical, "Error"
    Exit Sub
End Sub

Private Sub cmdGetList_Click()
    On Error GoTo Err

    Dim fileList() As String
    Dim listData As String
    Dim i As Integer
    Dim itemAdded As Boolean
    itemAdded = False
    
    listData = Inet1.OpenURL("http://www.patorjk.com/CodeAddIns/CodeAddIns.txt")
    fileList = Split(listData, vbNewLine)
   
    lstAddIns.Clear
    For i = 0 To UBound(fileList)
        If Dir(dirName + "\" + Trim$(fileList(i)), vbNormal) = "" Then
            lstAddIns.AddItem Trim$(fileList(i))
            itemAdded = True
        End If
    Next
    
    If itemAdded = False Then
        MsgBox "It appears there are no new add-ins to download.", vbInformation, "Notice"
    End If
    Exit Sub
    
Err:
    MsgBox "An error occurred while trying to download the list.", vbCritical, "Error"
    Exit Sub
End Sub

Private Sub Form_Load()
    dirName = "Code Add-Ins"
End Sub

